<template>
  <div>
    <PageCard
      class="pageCard-padding background-header"
      :bordering="false"
      fontWeight="bold"
      titleSize=".925rem"
      :title="$t('deposit.payByEos.title')">
    </PageCard>
    <PageCard
      :bordering="false">
      <slider
        class="pt-10"
        :val="value"
        :max="1000"
        @change="(val) => $emit('input', val)"></slider>
      <div class="pageCard_inner">
        <div class="payment_info">
          <div
            class="payment_info-item"
            @click="copy(accountName)">
            <div class="flex flex-middle">
              <div class="payment_info-item-label">{{$t('deposit.payByEos.address')}}:<span class="color-red" style="margin-left: 5px;">*</span>
              </div>
              <div class="payment_info-item-val">{{accountName}}</div>
            </div>
            <IconCopy
              fill="#636b7b"
              @click="copy(accountName)"></IconCopy>
          </div>
          <div
            class="payment_info-item">
            <div class="flex flex-middle">
              <div
                class="payment_info-item-label"
                style="display: flex; align-items: flex-end;">{{$t('deposit.payByEos.memo')}}:<span
                class="color-red"
                style="margin-left:5px;"
                v-if="requiredMemo">*</span>
              </div>
              <div class="payment_info-item-val"><input
                :disabled="inputMemoDisabled"
                class="payment_info-input"
                type="text"
                v-model="inputMemo"></div>
            </div>
            <IconCopy
              fill="#636b7b"
              @click.native="copy(inputMemo)"></IconCopy>
          </div>
          <div class="payment_info-item">
            <div class="flex">
              <div class="payment_info-item-label">{{$t('deposit.payByEos.amount')}}:</div>
              <div
                class="payment_info-item-val"
                style="color: #b3d9dd;">{{value}} EOS
              </div>
            </div>
          </div>
        </div>
      </div>
    </PageCard>
    <PageCard :bordering="false">
      <div class="exchange_info-tips">
        <div>
          <div class="text-bold mb-10 text-uppercase">
            {{$t('deposit.payByEos.tip1.title')}}
          </div>
          <div class="deposit-subtitle-description text-09">{{$t('deposit.payByEos.tip1.text')}}</div>
        </div>
      </div>
      <div
        class="exchange_info-tips"
        style="background-color: #1f2c45;">
        <div>
          <div class="text-bold mb-10 text-uppercase">
            {{$t('deposit.payByEos.tip2.title')}}
          </div>
          <div class="deposit-subtitle-description text-09">{{$t('deposit.payByEos.tip2.text')}}</div>
        </div>
      </div>
      <div class="exchange_info text-center">
        <BtnDark
          color="#8591a9"
          borderColor="#36d253"
          @click="copyInvoice">{{$t('deposit.copy')}}
          <template slot="img">
            <IconCopy
              class="mt-3p ml-10"
              fill="#8591a9"></IconCopy>
          </template>
        </BtnDark>
      </div>
      <div class="attention">
        <div class="attention-breaker">
          {{$t('deposit.payByEos.attentionTitle')}}
        </div>
        <div class="attention-info">
          <div v-if="accountName==='popcornmaker'">{{$t('deposit.payByEos.attentionText_2')}}</div>
          <div v-else>{{$t('deposit.payByEos.attentionText')}}</div>
          <div><a href="/What is MEMO.pdf" target="_blank">{{$t('deposit.payByEos.learnMore')}}</a></div>
        </div>
      </div>
    </PageCard>
  </div>
</template>

<script>
  import PageCard from '~/components/UI/PageCard';
  import Btn from '~/components/UI/BtnSign';
  import IconCopy from '~/components/UI/icons/icon-copy';
  import copyClipboard from '~/components/utils/copy';
  import BtnDark from '~/components/UI/BtnSign_dark';
  import BtnSign from '~/components/UI/BtnSign';

  import notification
    from '~/components/UI/Notification/main.js';
  import slider from './slider';


  export default {
    name: "Part2",
    props: {
      inputMemoDisabled: {
        type: Boolean,
        default: true
      },
      requiredMemo: {
        type: Boolean,
        default: false
      },
      accountName: {
        type: String,
        default: localStorage.getItem('accountname')
      },
      memo: {
        type: String,
        default: 'Checkout 16Bit.Game!'
      },
      value: {
        type: Number,
        default: 5
      }
    },
    data() {
      return {
        inputMemo: ''
      }
    },
    components: {
      PageCard,
      Btn,
      IconCopy,
      BtnDark,
      BtnSign,
      slider
    },
    methods: {
      async submit(e) {
        let balance = await this.$store.dispatch('wallet/checkBalance', {
          accountname: 'jetpack.x',
          needCommit: false
        });
        if (parseFloat(balance || 0) < this.value) {
          e.preventDefault();
          return notification.info({
            message: 'Platform balance is not enough'
          });
        }
        e.preventDefault();
        return notification.info({
          message: 'Not available now'
        });
      },
      copy(text) {
        copyClipboard(text, this.$t('common.copy'))
      },
      copyInvoice() {
        let memo = '';
        if(this.accountName !== 'popcornmaker') {
          memo = `

Memo:
${this.inputMemo},

`
        }

        const text = `
Address:
${this.accountName},
${memo}
Amount:
${this.value}(EOS)
        `;
        this.copy(text);
      }
    },
    watch: {
      'memo': {
        immediate: true,
        handler() {
          this.inputMemo = this.memo;
        }
      }
    }
  }
</script>
<style
  lang="scss"
  scoped>
  .background-header {
    background-color: #303d55;
  }

  .pageCard {
    &_inner {
      padding: 20px;
      background-color: #313b50;
    }
    &_video {
      padding: 20px;
      background-color: #1b2229;
      color: #84878b;
      white-space: pre-line;
      line-height: 1.4;
    }
  }

  .payment_info {
    &-input {
      color: #00bac3;
      background: transparent;
      border: none;
      text-overflow: ellipsis;
      margin-left: 5px;
    }
    &-item {
      display: flex;
      align-items: center;
      justify-content: space-between;
      padding: 10px 0px;
      &:not(:last-child) {
        border-bottom: 1px dashed #47556e;
      }
      &-label {
        color: #ffffff;
      }
      &-val {
        color: #00bac3;
        margin-left: 10px;
        white-space: nowrap;
        text-overflow: ellipsis;
        overflow: hidden;
        max-width: 180px;
        width: 100%;
      }
    }
  }

  .attention {
    &-breaker {
      background-color: #adbcc2;
      text-transform: uppercase;
      padding: 15px 20px;
      color: #0f1d35;
      font-size: 1.2rem;
      letter-spacing: 1.4px;
    }
    &-info {
      white-space: pre-line;
      color: #858688;
      background-color: #c7d3d8;
      padding: 15px 20px;
      letter-spacing: 1.4px;
      line-height: 1.4;
      font-size: .725rem;
    }
  }

  .exchange_info {
    background-color: #1b2229;
    padding: 20px 0px;
    &-tips {
      background-color: #283349;
      padding: 20px;
    }
    &-title {
      text-transform: uppercase;
      font-weight: bold;
    }
    &-subtitle {
      color: #7f848c;
    }
    &-img {
      max-width: 200px;
      width: 100%;
    }
  }
</style>
